# 3.5.5. build_data

resource type: build_data
  Attributes:

    - buildid (integer) – id of the build the build data is attached to

    - name (string) – the name of the build data

    - length (integer) – the number of bytes in the build data

    - source (string) – a string identifying the source of the data

`example`

>     {
>         "buildid": 31,
>         "name": "stored_data_name",
>         "length": 10,
>         "source": "Step XYZ"
>     }

This resource represents a key-value data pair associated to a build. A build can have any number of key-value pairs. The data is intended to be used for temporary purposes, until the build and all actions associated to it (such as reporters) are finished.

The value is a binary of potentially large size. There are two sets of APIs. One returns the properties of the key-value data pairs, such as key name and value length. Another returns the actual value as binary data.

## 3.5.5.1. Update Methods

All update methods are available as attributes of `master.data.updates`.

class buildbot.data.build_data.BuildData
  setBuildData(buildid, name, value, source)
    Parameters:

      - buildid (integer) – build id to attach data to

      - name (unicode) – the name of the data

      - value (bytestr) – the value of the data as `bytes`

      - source (unicode) – a string identifying the source of the data

    Returns:

      Deferred

    Adds or replaces build data attached to the build.

## 3.5.5.2. Endpoints

path: /builders/{builderid_or_buildername}/builds/{build_number}/data
  Path Keys:

    - builderid_or_buildername (number|string) – the ID or name of the builder

    - build_number (number) – the number of the build within the builder

This path selects all build data set for the build

`GET`
  `returns`

    `collection` of `build_data`

path: /builders/{builderid_or_buildername}/builds/{build_number}/data/{build_data_name}
  Path Keys:

    - builderid_or_buildername (number|string) – the ID or name of the builder

    - build_number (number) – the number of the build within the builder

    - build_data_name (string) – the name of build data

This path selects a build data with specific name

`GET`
  `returns`

    `collection` of `build_data`

path: /builds/{buildid}/data
  Path Keys:

    buildid (number) – the id of the build

This path selects all build data set for the build

`GET`
  `returns`

    `collection` of `build_data`

path: /builds/{buildid}/data/{build_data_name}
  Path Keys:

    - buildid (number) – the id of the build

    - build_data_name (string) – the name of build data

This path selects a build data with specific name

`GET`
  `returns`

    `collection` of `build_data`